﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using takvim.v01.Models;

namespace takvim.v01.Controllers
{
    public class HomeController : Controller
    {
        DataClasses1DataContext db = new DataClasses1DataContext();
        public ActionResult Index()
        {
           
            var roomDB = new DataClasses1DataContext().Tesislers.ToList();
            var ownerDB = new DataClasses1DataContext().Salonlars.ToList();
            var katDB = new DataClasses1DataContext().Kategorilers.ToList();

            ViewBag.Tesisler = roomDB;
            ViewBag.Salonlar = ownerDB;
            List<String> resources = new List<String>();
            resources.Add("Tesisler");
            resources.Add("Salonlar");
            ViewBag.Resources = resources;
            ViewBag.kategoriler = katDB;
            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
        public JsonResult GetData()
        {
            IEnumerable data = new DataClasses1DataContext().Rezervasyonlars.Take(100); // nw.Appointment.Take(5);
            return Json(data, JsonRequestBehavior.AllowGet);
            
        }
        public JsonResult Batch(EditParams param)
        {
            
            if (param.action == "insert" || (param.action == "batch" && param.added != null))          // this block of code will execute while inserting the appointments
            {
                var value = param.action == "insert" ? param.value : param.added[0];
                int intMax = db.Rezervasyonlars.ToList().Count > 0 ? db.Rezervasyonlars.ToList().Max(p => p.ID) : 1;
                DateTime baslangic = Convert.ToDateTime(value.Baslangic);
                DateTime bitis = Convert.ToDateTime(value.Bitis);
                Rezervasyonlar rez = new Rezervasyonlar()
                {
                    ID = value.ID,
                    Baslangic = baslangic,
                    Bitis = bitis,
                    BaslangicZamanDilimi = value.BaslangicZamanDilimi,
                    BitisZamanDilimi = value.BitisZamanDilimi,
                    Konu = value.Konu,
                    Aciklama = value.Aciklama,
                    Tekrar = value.Tekrar,
                    TesisID = value.TesisID,
                    SalonID = value.SalonID,
                    KategoriID = value.KategoriID,
                    ButunGunMu = value.ButunGunMu,
                    TekrarKurali = value.TekrarKurali
                };
                db.Rezervasyonlars.InsertOnSubmit(rez);
                db.SubmitChanges();
            }
            if (param.action == "remove" || param.deleted != null)                                        // this block of code will execute while removing the appointment
            {
                if (param.action == "remove")
                {
                    int key = Convert.ToInt32(param.key);
                    Rezervasyonlar app = db.Rezervasyonlars.Where(c => c.ID == key).FirstOrDefault();
                    if (app != null) db.Rezervasyonlars.DeleteOnSubmit(app);
                }
                else
                {
                    foreach (var apps in param.deleted)
                    {
                        Rezervasyonlar app = db.Rezervasyonlars.Where(c => c.ID == apps.ID).FirstOrDefault();
                        if (apps != null) db.Rezervasyonlars.DeleteOnSubmit(app);
                    }
                }
                db.SubmitChanges();
            }
            if ((param.action == "batch" && param.changed != null) || param.action == "update")   // this block of code will execute while updating the appointment
            {
                var value = param.action == "update" ? param.value : param.changed[0];
                var filterData = db.Rezervasyonlars.Where(c => c.ID == value.ID);

                if (filterData.Count() > 0)
                {
                    DateTime baslangic = Convert.ToDateTime(value.Baslangic);
                    DateTime endTime = Convert.ToDateTime(value.Bitis);
                    Rezervasyonlar appoint = db.Rezervasyonlars.Single(A => A.ID == value.ID);
                    appoint.Baslangic = baslangic;
                    appoint.Bitis = endTime;
                    appoint.Konu = value.Konu;
                    appoint.BaslangicZamanDilimi = value.BaslangicZamanDilimi;
                    appoint.BitisZamanDilimi = value.BitisZamanDilimi;
                    appoint.Aciklama = value.Aciklama;
                    appoint.SalonID = value.SalonID;
                    appoint.Tekrar = Convert.ToByte(value.Tekrar);
                    appoint.TesisID = value.TesisID;
                    appoint.ButunGunMu = value.ButunGunMu;
                    appoint.KategoriID = value.KategoriID;
                    appoint.TekrarKurali = value.TekrarKurali;
                }
                db.SubmitChanges();
            }
            IEnumerable data = new DataClasses1DataContext().Rezervasyonlars.Take(500); // nw.Appointment.Take(5);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}